%{
#open "syntaxe_scheme";;
%}

%token LPAR
%token RPAR
%token DOT
%token QUOTE
%token BACKQUOTE
%token COMMA
%token COMMAAT
%token <string> SYMBOL
%token <int> INT
%token <float> FLOAT
%token <string> STRING
%token <char> CHAR
%token EOF
%token NIL
%token TRUE

%start Programme
%type <syntaxe_scheme__programme_lisp> Programme

%%

Programme:
    Expr Programme		{ $1::$2 }
  | EOF				{ [] }
;

Expr:
    LPAR RPAR			{ Atome Nil }
  | LPAR Expr_list RPAR		{ $2 }
  | SYMBOL 			{ Atome (Symbole $1) }
  | QUOTE Expr			{ Cons (Atome(Symbole "Quote"),
                                        Cons ($2,Atome Nil)) }
  | INT				{ Atome (SInt $1) }
  | FLOAT			{ Atome (SFloat $1) }
  | STRING			{ Atome (SString $1) }
  | CHAR			{ Atome (SChar $1) }
  | NIL				{ Atome Nil }
  | TRUE			{ Atome True }
;

Expr_list:
    Expr Expr_list		{ Cons ($1,$2) }
  | Expr DOT Expr		{ Cons ($1,$3) }
  | Expr			{ Cons ($1,Atome Nil) }
;

/* Reste a faire les macro-caractres ` , ,@ */





